;
; fill_edge.s													9/30/2008
;
;   Polygon fill edge routine.  Fills in a polygon contained by edges that
; were set by the set_edge routine.
;
; author:
;
;   Bart Jaszcz
;

	
		.include "graphics.inc"
		.importzp ptr2, ptr3
		.import _left_edge, _right_edge
		.import _h_line
		.export _fill_edge
		.macpack generic

; 16 bit variables:

left = ptr2						; left polygon edge
right = ptr3					; right polygon edge
		
.proc _fill_edge

_fill_edge:		lda #<_left_edge	; get low byte of left_edge address
				sta left			; set low byte of left pointer
				lda #>_left_edge	; get high byte of left_edge address
				sta left+1			; set high byte of left pointer

				lda #<_right_edge	; get low byte of right_edge address
				sta right			; set low byte of right pointer
				lda #>_right_edge	; get high byte of right_edge address
				sta right+1			; set high byte of right pointer
				
loop:			lda Y1				; get Y1 coordinate
				cmp Y0				; compare Y0 coordinate
				bcs	cont			; continue if Y0 <= Y1
				rts					; return if Y0 > Y1

cont:			ldy Y0				; get Y0 into y register
				lda (left), y		; get left bound
				sta X0
				lda (right), y		; get right bound
				sta X1
				jsr _h_line			; call horizontal line (X0,X1,Y0)
				inc Y0				; increment Y0
				bne loop			; always branch to loop

.endproc




