/*
 
   trig.h
   
   Trigonometric functions for small machines.
   
   author:
   Bart Jaszcz
 
 */
 
// number of samples in sine table
#define SINTAB_SIZE 256
// sine table size as a shift (256 == 1<<8)
#define SINTAB_SIZE_SHIFT 8
// sine table size as a mask (0xff == 8 bits)
#define SINTAB_SIZE_MASK 0xff
// sine samples in table were multipled by this factor
#define SINTAB_SCALE 65535
// shift needed to get integer into an 8:8 fixed point number
#define FP_SHIFT 8
// all functions use PI/SINTAB_SIZE angles
long sin(int a);  // sine of angle
long cos(int a);  // cosine of angle

