;
; v_line.s
;
;	ANTIC mode E vertical line routine
;
; author:
;
;   Bart Jaszcz
;

		.include "graphics.inc"
		.importzp ptr1, tmp1, tmp2, tmp3, tmp4
		.import _xy_plot_0
		.export _v_line
		.macpack generic
		
; 16 bit variables

scan = ptr1							; scanline pointer

; 8 bit variables

ox = tmp3							; offset-x
cy = tmp4							; current-y

; plot sets these up:

im = tmp2							; inverted mask
pv = tmp1							; pixel value

.proc _v_line

_v_line:		lda Y1				; is Y1 < Y0? (not allowed)
				sub Y0
				bcs skip			; no, skip over rts
				rts					; yes, return immediately

skip:			bne cont			; was Y1 == Y0? if not, continue to main code
				jsr _xy_plot_0		; otherwise just plot one endpoint (the first)
				rts					; and return

cont:			tax					; transfer y difference to x (loop counter)
				jsr _xy_plot_0		; let plot set up masks and offsets
				sty ox				; store x offset set up by plot in ox
				lda Y0				; set current y = Y0
				sta cy
loop:			inc cy				; increment current y coordinate
				ldy cy				; load current y coordinate into y register
				lda (SH), y			; load scanline pointer high byte into a 
				sta scan+1			; store it to high byte of scan
				lda (SL), y			; load scanline pointer low byte into a 
				sta scan			; store it to low byte of scan
				ldy ox				; retrive x offset from ox
				lda (scan), y		; get the screen byte into a
				and im				; and it with inverted mask
				ora pv				; then or it with pixel value
				sta (scan), y		; store result in the screen byte
				dex					; decrement loop counter
				bne loop			; loop until zero
				rts					; return to calling program
.endproc

